//
//  cgps.js 
//  IDVault-M
//
//  Created by Thankasala Prasanna on 11/25/11.
//  Copyright 2011 WhiteSky Inc. All rights reserved.
//

// This is a global array, that gets added to the Window object.
var loginElementsArray_Input = new Array();
var loginElementsArray_Submit = new Array();
var firstSubmitKey	= "";

var submitEl2ndPage = "";

// Credit Card functions
// Global attribute that is used to set the activeElement value
var currCreditCardVal;

var loginElementsJSONObj = null;
var submitButtonClickDetected = false;
var handleBlank2ndPage = false;
var siteIsTrivial = false;
var gHandleAsAjax = false;
var gHandlePlaybackAsAjax = false;
var gPlaybackDone = false;
var gSubmitButtonNodeListenerAdded = false;
var gNotificationSentToClient = false;

function myalert(s)
{
	// comment/uncomment as required.
//	alert(s);
	console.log("Javascript: " + s);
}

// Trim left & right
function trim(stringToTrim)
{
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}

// Trim left
function ltrim(stringToTrim) 
{
	return stringToTrim.replace(/^\s+/,"");
}

// Trim right
function rtrim(stringToTrim) 
{
	return stringToTrim.replace(/\s+$/,"");
}

// 
function isEmpty(str) {
    return (!str || 0 === str.length);
}

function isBlank(str) 
{
	// /^\s*$/  => from start of string, find multiple whitespace chars(spaces, tabs, linebreaks), upto end of line
	// and test if input string matches this pattern.
	var regex = /^\s*$/;
    return (!str || regex.test(str));
}

// To get length(count) of an array
Object.size = function(obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) 
		{
			size++;
		}
    }
	//myalert ('Object size returned: ' + size);
	
    return size;
};

// indexOf is a native method of Array, but not supported in some browser versions.
// So defining one here. 'a' is and HTMLElement array here...
function indexInArray(a, obj) {
    for (var i = 0; i < a.length; i++) {
        if (a[i].value === obj) {
            return i;
        }
    }
    return -1;
}

//------------------------------------------------------------------------------------------
// Helper to show toast and alert
//------------------------------------------------------------------------------------------
function android_alert(inpString) {
    //SafeSearch.showToast('<:j:s:> ' + inpString);
    
    //this is like the java script return
    //SafeSearch.setLocalData("hello.")
    
   // myalert(inpString);
}

//------------------------------------------------------------------------------------------
// Global listeners 
//------------------------------------------------------------------------------------------

// Event-listener to intercept/interpret "pagehide" event (instead of pageunload) 
// Add this listener to event that gets fired before navigation is going to occur away from this page.
// "pageunload" may not be fired if browser caches pages. However, looks like
// this event will be fired even if that happens.
// Before leaving this page, get all loginElements and notify caller (android) 
window.addEventListener("pagehide", handlePageUnloadHide, false);

// Blocking this...Needs further investigation.

window.addEventListener("keyup", handleGoButton, false);
//window.addEventListener("submit", handleGoButton, false);

function handleGoButton(e) {
   // myalert('handleGoButton ' + e.keyCode);
    if (e.keyCode == 13) {
    	myalert('Got Go button');
    	submitButtonClickDetected = true;
    	handleOnBlur(e);
    	if (siteIsTrivial) {
    		Android_callbackForTrivial();
    	} else {
    	submitButtonClicked(e);
    	//	handlePageUnloadHide();
    	}
        //return false;
    }
}


/*
for (var k=0; k < window.frames.length; k++) {
	var iframe = window.frames[k];
	// sometimes glamorous naming of variable makes your code working :)
	if (iframe) {
		iframe.addEventListener('load', function(event) {alert('load');}, false);
	}

	var iDoc = getDocumentForFrame(iframe);
	if (iDoc) {
			android_alert('Adding Pagehide and unload to frame document');
		    //iDoc.addEventListener('pagehide', function(event) {parent.handlePageUnloadHide();}, false);
		    //iDoc.addEventListener('unload', function(event) {parent.handlePageUnloadHide();}, false);
		    //iDoc.addEventListener('load', function(event) {parent.handlePageUnloadHide();}, false);

		    iDoc.addEventListener('pagehide', function(event) {alert('pagehide');}, false);
		    iDoc.addEventListener('unload', function(event) {alert('unload');}, false);
		    iDoc.addEventListener('load', function(event) {alert('load');}, false);

	};
}
*/

function handlePageUnloadHide() {
	if (submitButtonClickDetected) {
		android_alert('notifyBeforeExit: Sending notification to client');

		submitButtonClickDetected = false;
		sendNotificationToClient();
	}
	else if (handleBlank2ndPage) {
		// Get both the password and submit elements' data, and notify client
		handleBlank2ndPage = false;
		android_alert('notifyBeforeExit: Getting 2nd Page to client');

		var retString = "";
		for (var i=0; i<loginElementsJSONObj.loginElements.length; i++)
		{
			var node2ndPage;	// tmp that can point to either password or submit node.
			if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "password") {
				// return format: {status:"fail", rank:"0", msg:'', inpType:'', xPath:'', xPathValue:''};
				node2ndPage = eval('(' + get2ndPagePassword() + ')');
			} else if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit") {
				// return format: {status:"fail", rank:"0", msg:"None", inpType:"", xPath:"", xPathValue:""};
				node2ndPage = eval('(' + get2ndPageSubmitElement() + ')');
			}

			loginElementsJSONObj.loginElements[i].xPath = (node2ndPage) ? node2ndPage.xPath : "";
			loginElementsJSONObj.loginElements[i].xPathValue = (node2ndPage) ? node2ndPage.xPathValue : "";
		}

		// Return loginElements
		retString = JSON.stringify(loginElementsJSONObj);

		android_alert('notifyBeforeExit: Sending 2nd Page to client:' + retString);
		AndroidCallback.setLoginElementsJSON(window.location.href, retString);
	}
}

// Event-listener to intercept/interpret AJAX response
// Some sites use AJAX to submit login requests, and in-place update login status or update the DOM appropriately
// This will not fire pageunload/pagehide kind of events.
// So, add a listener that listens on 'onreadystatechange' which gets called when a ajax response is received.
// If this response was received after a submit button was clicked, assume that the response is related to
// the request. Get all loginElements and notify caller (android)
// TODO: Test more and also validate adding listener at the document level. ie., think iframes/frames.
/*document.addEventListener('onreadystatechange', fnAjaxResponseHandler, false);
function fnAjaxResponseHandler()
{
   if ( (document.readyState=="complete") && submitButtonClickDetected )
   {
		android_alert('fnAjaxResponseHandler: Sending notification to client');

		submitButtonClickDetected = false;
		sendNotificationToClient();
   }
}
*/

(function(XHR) {
    "use strict";

    var open = XHR.prototype.open;
    var send = XHR.prototype.send;

    XHR.prototype.open = function(method, url, async, user, pass) {
        this._url = url;
        open.call(this, method, url, async, user, pass);
        android_alert('fnAjaxResponseHandler: Open');
    };

    XHR.prototype.send = function(data) {
        var self = this;
        var oldOnReadyStateChange;
        var url = this._url;

        android_alert('fnAjaxResponseHandler: Send()');

        function onReadyStateChange() {
   			//android_alert('fnAjaxResponseHandler: onReadyStateChange()');
            retryRecordOrPlayback();

   			if(self.readyState == 4 /* complete */) {
                /* This is where you can put code that you want to execute post-complete*/
                /* URL is kept in this._url */

        	   if (submitButtonClickDetected )
        	   {
        			android_alert('fnAjaxResponseHandler: Sending notification to client');

        			submitButtonClickDetected = false;
        			sendNotificationToClient();
        	   }
            }

            if(oldOnReadyStateChange) {
                oldOnReadyStateChange();
            }
        }

        /* Set xhr.noIntercept to true to disable the interceptor for a particular call */
        if(!this.noIntercept) {
            if(this.addEventListener) {
                this.addEventListener("readystatechange", onReadyStateChange, false);
            } else {
                oldOnReadyStateChange = this.onreadystatechange;
                this.onreadystatechange = onReadyStateChange;
            }
        }

        send.call(this, data);
    }
})(XMLHttpRequest);

function Android_verify_page(loginElementsJSON) {
 	myalert('Android_verify_page');

 	found = true;
     var jsonObj = eval('(' + JSON.stringify(loginElementsJSON) + ')');

         for (var i=0; i<jsonObj.loginElements.length; i++)
         {
             var nodeObj = findNodeForXPath(jsonObj.loginElements[i].xPath);
             if (nodeObj.node != null)
                 continue;

             found = false;
             //break;
         }

 	android_alert('Callback to Android - page found:' + found);
 	AndroidCallback.notifyPageStatus(window.location.href, found);
 	myalert('notifyPageStatus called');

 }

 function Android_verify_first_page(loginElementsJSON) {
 	myalert('Android_verify_first_page');

 	found = true;
     var jsonObj = eval('(' + JSON.stringify(loginElementsJSON) + ')');

         for (var i=0; i<jsonObj.loginElements.length; i++)
         {
          	 myalert('Login Elements = ' + jsonObj.loginElements[i].xPath);
             var nodeObj = findNodeForXPath(jsonObj.loginElements[i].xPath);
             if (nodeObj.node != null)
             {
                 jsonObj.loginElements[i].node = nodeObj.node;
                 continue;
             }
             found = false;
             //break;
         }

 	android_alert('Callback to Android - first page found:' + found);
 	AndroidCallback.notifyFirstPageStatus(found);
 	myalert('notifyFirstPageStatus called');

 }

function Android_record(isTrivial, accType, loginElementsJSON) {
	myalert('Android_record :' + accType);
	if(document.readyState == "complete") {
	    myalert('DOCUMENT READY');
    } else {
    	myalert('DOCUMENT NO READY');
    }

    if( accType == "OTHER" && isPasswordInPage() == "0") {
    	myalert('No password on Page for OTHER type of account hence Returning:');
    	return;
    }

	siteIsTrivial = isTrivial;
	if ( (isTrivial == "1") || (isTrivial == "true") ) {
		Android_startListenersForTrivial();
	} else {
	    loginElementsJSONObj = eval('(' + JSON.stringify(loginElementsJSON) + ')');
	    Android_prepareToBindListenersForNonTrivial();

		//Android_startListenersForNonTrivial(loginElementsJSON);
	}
}

//------------------------------------------------------------------------------------------
// Trivial handlers/wrapper functions
//------------------------------------------------------------------------------------------

// Starts the Recording Process - used for TRIVIAL sites.
// Add listeners to the focus/blur/click events and handle appropriately.
function Android_startListenersForTrivial() {
	myalert('Android_startListenersForTrivial');
	// Don't check for password in page.
	// On some sites, we need to click on a link that opens up a login form.
	// We want to capture those clicks too.
	//if (isPasswordInPage() == "1") {
		_dom_trackOnFocus();
	//}
}

// Push loginElements data to caller(android), when a Submit element has been
// detected to be clicked.
// TODO: Accurately identify Submit element and any other 'clickable' element.
// Also, use pagehide event to callback
function Android_callbackForTrivial() {
	myalert('Android_callbackForTrivial');
	// Call back only if we have a password element captured (will be a type)
	var allElements = getAllLoginElements();
	if (allElements.search("inpType:password") != -1) {
		myalert('Callback to Trivial - found password:' + allElements);
		AndroidCallback.setLoginElements(window.location.href, allElements);
	} else {
		android_alert('No Callback to Trivial - password not found');
	}
}

// jQuery global event handlers

// Called when DOM is ready.
$(document).ready(function() {
  	//alert("Ajax: got Ready");
});

// Called after every ajax successful call.
$(document).ajaxSuccess(function( event, xhr, settings ) {
	//alert("AjaxSuccess: urL: " + settings.url + " initiated by Target: " +
	// event.target.nodeName + " of type: " + event.type + " keyCode: " + event.which);

  //  myalert("Got ajaxSuccess");
    retryRecordOrPlayback();
});

// After all ajax requests received.., bind listener(s)
$(document).ajaxStop(function() {
 //   myalert("Got ajaxStop");
    retryRecordOrPlayback();
});

//$.mobile.changePage(function() {
//    myalert('Detected mobile page change event');
//});

$(document).bind("pagehide", function(event, ui) {
    myalert('pagehide completed');
});

function retryRecordOrPlayback()
{
	if (gHandleAsAjax && !gSubmitButtonNodeListenerAdded) {
  	    myalert("retryRecordOrPlayback: Start Listeners now");
	    Android_startListenersForNonTrivial(loginElementsJSONObj);
//	} else if (gHandleAsAjax && !submitButtonClickDetected) {
//  	    myalert("retryRecordOrPlayback: Forcing submit action");
//	    submitButtonClicked(null);
	} else if (gHandlePlaybackAsAjax && !gPlaybackDone) {
      	myalert("retryRecordOrPlayback: Playback now");
	    Android_playback(loginElementsJSONObj);
	}
}

function retryAfterAllAjaxSubmissions() {
	//alert("retryAfterAllAjaxSubmissions");
	// .ajaxStop() will be called at the end of all requests. Set flag to retry..
	gHandleAsAjax = true;
}
//------------------------------------------------------------------------------------------
// NonTrivial handlers/wrapper functions
// ------------------------------------------------------------------------------------------

// Check if element(s) has notifyOnSubmit. If it does, add Listeners when .ajaxStop event
// occurs. If not, startListeners right away (which is called on onFinalPageFinished)
function Android_prepareToBindListenersForNonTrivial()
{
  	myalert("Android_prepareToBindListenersForNonTrivial");

    // Try and bind right away. DOM may not be fully ready if ajax site
    // Bofa on android webview behaves differently from iOS
    Android_startListenersForNonTrivial(loginElementsJSONObj);

    if (!gSubmitButtonNodeListenerAdded) {
        for (var i=0; i<loginElementsJSONObj.loginElements.length; i++)
        {
            if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit")
            {
                // need to handle 'notifyOnSubmit'
                if (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "1") {
                    retryAfterAllAjaxSubmissions();
                    myalert("Found notify on submit");
                    break;
                }
            }
        }
    }
}

// Starts the Recording Process - used for NON-TRIVIAL sites.
//
// For NonTrivial sites, xPaths for all required loginElements are supplied from TNSite.
// Strategy is: Locate the Submit element and listen for a click event on this element.
// When it occurs, get all login credentials based on xPaths again already available, and notify
// client.
// 	  Format of loginElementsJSON is:
//				{"loginElements" : [	{	"inpType": "text",
//										 	"xPath":"/html/body/...",
//											"xPathValue":"myusername"
//										},
//										{	"inpType": "password",
//											"xPath":"/html/body/...",
//											"xPathValue":"mypassword"
//										},
//										...
//									]
//				}
function Android_startListenersForNonTrivial(loginElementsJSON)
{
	var retString = "";
	bSecondPageIsBlank = false;

	gSubmitButtonNodeListenerAdded = false;

	myalert('Android_startListenersForNonTrivial:' + JSON.stringify(loginElementsJSON));

	try {
		// Not necessary, but just in case loginElementsJSON is ill-formed
		// Moved the line below into caller...
		//loginElementsJSONObj = eval('(' + JSON.stringify(loginElementsJSON) + ')');

		for (var i=0; i<loginElementsJSONObj.loginElements.length; i++) {
			if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit") {
				// Find the node and add listener
				var submitButtonNode;
				var nodeObj;
				try {
					var xPath = loginElementsJSONObj.loginElements[i].xPath;
					if ((loginElementsJSONObj.pageNumber == "1") && isBlank(xPath) )
					{
						bSecondPageIsBlank = true;
						break;
					}
					nodeObj = findNodeForXPath(loginElementsJSONObj.loginElements[i].xPath);
					submitButtonNode = nodeObj.node;
				}
				catch(err)
				{
					msg = "submitCredentialEx: exception thrown from findNodeForXPath: " + err.message;
					myalert(msg);
					//return {"status":"fail", "msg":msg};
					return;
				}

				myalert((submitButtonNode == null ? "SubmitButtonNode not found" : "SubmitButtonNode found"));

				// Add listener
				if (submitButtonNode){

                    if (submitButtonNode.hasAttribute("disabled")===true) {
                        myalert(' Removing attributes {disabled} from Submit element');
                        submitButtonNode.removeAttribute("disabled");
                    }

                    // If 2-page, we may be looking for 2-nd page elements too early, esp if ajax sites
                    // like bofa-mobile. We may be looking for 2nd page elements on 1st page !!
                    // Submit element id is the same on all 3 pages for bofa...so make sure we are strict about
                    // it. Check the ranking...
                    var isCorrectElement = false;

				    var resultObj = nodeObj.obj;
                    if ( (loginElementsJSONObj.pageNumber == "1") &&
                                (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "1") &&
                                ((resultObj.rank == "1") || (resultObj.rank == "3") || (resultObj.rank == "4")) )
                    {
                        // With bofa, 2nd page submit element has same exact xpath as password page !!
                        // So, check additionally for pwd.
                        android_alert('Checking for pwd element in ' + loginElementsJSONObj.pageNumber);
                        var pwdNodeObj = findNodeForXPath(loginElementsJSONObj.loginElements[0].xPath);
                        var pwdResultObj = pwdNodeObj.obj;
                        if ((pwdResultObj.rank == "1") || (pwdResultObj.rank == "3") || (pwdResultObj.rank == "4")) {
                            isCorrectElement = true;
                        }
                    } else if ( (loginElementsJSONObj.pageNumber == "0") || (loginElementsJSONObj.pageNumber == "2") ||
                                ((loginElementsJSONObj.pageNumber == "1") &&
                                    (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "0")) )
                    {
                        isCorrectElement = true;
                    }

                    if (isCorrectElement) {
                        myalert(' Added listener to Submit button Page number: ' +
                                       loginElementsJSONObj.pageNumber + ' Match Ranking: ' + resultObj.rank);

                        submitButtonNode.addEventListener('click', submitButtonClicked, false);

                        gSubmitButtonNodeListenerAdded = true;
                    } else {
                        myalert('Did not add listener to Submit button. Incorrect element match. Page number: ' +
                                            loginElementsJSONObj.pageNumber + ' Match Ranking: ' + resultObj.rank);
                    }

					submitButtonClickDetected = false;
				}
			}
		}

		myalert("bSecondPageIsBlank = " + bSecondPageIsBlank + " Submit status = " + gSubmitButtonNodeListenerAdded);

		// If no submit element and we are on pageNumber = 1 (ie 2nd page, 0-based index),
		// then we have no xPath data for 2nd page. Use 'trivial' kind of algorithm to record data
		if (bSecondPageIsBlank) {
			// This keeps track of the submit button. After it is clicked, we will get a new page
			// navigate event, which we detect here through "pagehide" DOM event
			//
			handleBlank2ndPage = true;
			_dom_trackSubmitButton();
		}

		if (loginElementsJSONObj.pageNumber == "0")
		{
		    myalert("Hooking DOM focus events");
		    _dom_trackOnFocus();
		}
	}
	catch(err) {
		android_alert('Failed to parse JSON properly');
	}
}

// NonTrivial Submit button-click handler
//
// Set a flag that a click has occurred. Then,
// 1. A pagehide/pageunload event will follow
// or
// 2. an Ajax response will be received if login request was made in Ajax method.
// In either case, notify caller with loginElements data.
// We don't want to notify caller in this handler 'cos we want all the default handlers to have
// executed for the click event...in many nonTrivial sites data is transferred from visible elements to
// hidden elements either during onBlur or when a submit button is clicked (Fidelity). We want that to
// take place before we grab the credential information
function submitButtonClicked( event ) {
	//if ( event.preventDefault )
	//	event.preventDefault();
	//event.returnValue = false;
	myalert('submitButtonClicked: got click');
	submitButtonClickDetected = true;
	gNotificationSentToClient = false;

	// If NonTrivial site has marked the submit element as 'NotifyOnSubmit', then the reliable way
	// to record is to notify the client as soon as submit button gets a click.
	// Ex: TD Bank: Login form is inside an iFrame and page navigates inside the iFrame don't seem to be
	// easily trappable..iFrame src is on same domain. TN Site is marked to notify on submitbutton click.
	// We don't want to do this by default, because of cases like Fidelity, which populates credentials into
	// hidden fields only on submit button click and before form submit. In this case, we want to let the form submit,
	// and before page navigates out (pagehide, pageunload..), we trap it.
	for (var i=0; i<loginElementsJSONObj.loginElements.length; i++)
	{
		var notifyOnSubmit;
		if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit")
		{
			// need to handle 'notifyOnSubmit'
			if (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "1") {
    			android_alert('submitButtonClicked: NotifyOnSubmit is on. Sending notification to client');

    			//submitButtonClickDetected = false;
    			sendNotificationToClient();
			}
		}
	}
}

// NonTrivial Recording...
// Submit button was clicked and either a pagehide occurred or an Ajax response was received
// Notify client(caller) with appropriate loginElement data
function sendNotificationToClient()
{
	var retString = "";
	var hasNotifyOnSubmit = false;

	// We are interested only in input elements (text and pwd).
	//
	for (var i=0; i<loginElementsJSONObj.loginElements.length; i++)
	{
		var xPath;
		if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() != "submit")
		{
			xPath = loginElementsJSONObj.loginElements[i].xPath;
			// getValueForXPath returns a string. convert to JSON and get value
			var retObj = eval('(' + getValueForXPath(xPath) + ')');

			// need to handle 'optional'

			if ( (loginElementsJSONObj.loginElements[i].strict == "1") &&
					((retObj.status == "fail") || (!((retObj.rank == "1") || (retObj.rank == "4"))) ) )
			{
				android_alert('sendNotificationToClient:Setting status to 0, Rank is:' + retObj.rank);
				loginElementsJSONObj.status = "0";			// change to "fail"
				break;
			}
			loginElementsJSONObj.loginElements[i].xPathValue = (retObj) ? retObj.xPathValue : "";
		}
		else {
			if (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "1") {
			    hasNotifyOnSubmit = true;
            }
		}
	}

	// Return loginElements
	retString = JSON.stringify(loginElementsJSONObj);

	AndroidCallback.setLoginElementsJSON(window.location.href, retString);
    gNotificationSentToClient = true;

	// If Ajax, need to trigger next page navigation (onFinalPageFinished)
	if (gHandleAsAjax || (gSubmitButtonNodeListenerAdded && hasNotifyOnSubmit)) {
	  	myalert("Document location change after setLoginElementsJSON");
	    document.location = "cgps:onPageSubmitted:" + window.location.href;
	}
}

function Android_playback(loginElementsJSON) {

    myalert("Android_playback: Starting...");

    gPlaybackDone = false;

	try {
	    loginElementsJSONObj = eval('(' + JSON.stringify(loginElementsJSON) + ')');
	    // First, check if Submit element is already found on this page. If found, then
	    // DOM is almost surely in ReadyState, even if ajax based..In this case, playback
	    // right away. If not found, prepare for binding..
		for (var i=0; i<loginElementsJSONObj.loginElements.length; i++)
    	{
    		 myalert("For Loop" + i);
    		if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit")
            {
                var nodeObj = findNodeForXPath(loginElementsJSONObj.loginElements[i].xPath);
                var submitButtonNode = nodeObj.node;
                if (submitButtonNode)
                {
                    // If 2-page, we may be looking for 2-nd page elements too early, esp if ajax sites
                    // like bofa-mobile. We may be looking for 2nd page elements on 1st page !!
                    // Submit element id is the same on all 3 pages for bofa...so make sure we are strict about
                    // it. Check the ranking...
                    var isCorrectElement = false;

				    var resultObj = nodeObj.obj;
                    if ( (loginElementsJSONObj.pageNumber == "1") &&
                                (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "1") &&
                                ((resultObj.rank == "1") || (resultObj.rank == "3") || (resultObj.rank == "4")) )
                    {
                        // With bofa, 2nd page submit element has same exact xpath as password page !!
                        // So, check additionally for pwd.
                        android_alert('Checking for pwd element in ' + loginElementsJSONObj.pageNumber);
                        var pwdNodeObj = findNodeForXPath(loginElementsJSONObj.loginElements[0].xPath);
                        var pwdResultObj = pwdNodeObj.obj;
                        if ((pwdResultObj.rank == "1") || (pwdResultObj.rank == "3") || (pwdResultObj.rank == "4")) {
                            isCorrectElement = true;
                        }
                    } else if ( (loginElementsJSONObj.pageNumber == "0" || loginElementsJSONObj.pageNumber == "2") ||
                                ((loginElementsJSONObj.pageNumber == "1") &&
                                    (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "0")) )
                    {
                        isCorrectElement = true;
                    }

                    if (isCorrectElement) {
                        if (submitButtonNode.hasAttribute("disabled")===true) {
                            android_alert(' Removing attributes {disabled} from Submit element');
                            submitButtonNode.removeAttribute("disabled");
                        }

                        myalert("Found submit element. Calling Android_playbackNow");
                        Android_playbackNow(loginElementsJSONObj);
                    } else {
                        android_alert('Did not add listener to Submit button. Incorrect element match. Page number: ' +
                                            loginElementsJSONObj.pageNumber + ' Match Ranking: ' + resultObj.rank);
                    }
                }
            }
        }

        if (!gPlaybackDone)
	        Android_prepareToBindListenersForPlayback();
    }
	catch(err) {
		retObject.msg = 'Android_playback: Error occurred: ' + err.message;
	}
}

// Check if element(s) has notifyOnSubmit. If it does, add Listeners when .ajaxStop event
// occurs. If not, startListeners right away (which is called on onFinalPageFinished)
function Android_prepareToBindListenersForPlayback()
{
	for (var i=0; i<loginElementsJSONObj.loginElements.length; i++)
	{
		if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit")
		{
			// need to handle 'notifyOnSubmit'
			if (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "1") {
                gHandlePlaybackAsAjax = true;

                myalert("Android_prepareToBindListenersForPlayback: Setting Playbackajax");

                break;
            }
        }
    }

    // If not, try again now..
    //if (!gHandlePlaybackAsAjax) {
    //    Android_playbackNow(loginElementsJSONObj);
    //}
}

// PLAYBACK
// Common for both Trivial and Non-Trivial
// Format is {"loginElements" : [	{"inpType": "text", "xPath":"/html/body/...", "xPathValue":"myusername"},
//									{"inpType": "password", "xPath":"/html/body/...", "xPathValue":"mypassword"},
//									...
//								]
//			 }
// Iterate through elements, find the node, and call submitCredential (either sets the value or invokes a
// click if a submit button)
function Android_playbackNow(loginElementsJSON) {
	var retObject = {pageNumber:'0', status:'fail', msg:'None'};

	var hasNotifyOnSubmit = false;

	//android_alert('Android_playback: ' + JSON.stringify(loginElementsJSON));

	//if (isPasswordInPage() == "0") {
	//	AndroidCallback.playbackSuccessful(retStatus);
	//	return;		// nothing to do.
	//}
	try {
		// Not necessary, but just in case loginElementsJSON is ill-formed
		loginElementsJSONObj = eval('(' + JSON.stringify(loginElementsJSON) + ')');

		retObject.pageNumber = loginElementsJSONObj.pageNumber;

		for (var i=0; i<loginElementsJSONObj.loginElements.length; i++) {

			retObject.status = "fail";

			var xpathKeyElement;
			if (i==0) {
				xpathKeyElement = loginElementsJSONObj.loginElements[i].xPath;
			}

			try {
				var nodeObj = findNodeForXPath(loginElementsJSONObj.loginElements[i].xPath);
				var resultObj = nodeObj.obj;
				// resultObj.status is not set to "success" even if it succeeds, in findNodeForXPath().
				if ( (loginElementsJSONObj.loginElements[i].strict == "1") &&
						(!((resultObj.rank == "1") || (resultObj.rank == "4"))) )
						//((resultObj.status == "fail") || (!((resultObj.rank == "1") || (resultObj.rank == "4"))) ) )
				{
					android_alert(JSON.stringify(resultObj));
					retObject.msg = 'Android_playback: Strict lookup failed for: ' + loginElementsJSONObj.loginElements[i].xPath + ' with Ranking: ' + resultObj.rank;
					retObject.status = "fail";
					break;
				}

				var tmpNode = nodeObj.node;
				if (tmpNode) {
					retObject.status = "success";
				}
			}
			catch(err)
			{
				//android_alert('Android_playback: Failed to findNodeForXPath' + loginElementsJSONObj.loginElements[i].xPath);
				retObject.msg = 'Android_playback: Error occurred: ' + err.message;
				break;
			}

            if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit") {
                if (loginElementsJSONObj.loginElements[i].notifyOnSubmit == "1") {
                    hasNotifyOnSubmit = true;
                }
            }

			//android_alert('Android_playback: Submitting credential');

            if (loginElementsJSONObj.loginElements[i].inpType.toLowerCase() == "submit")
            {
                var loginElement = loginElementsJSONObj.loginElements[i];
                var keyElement = xpathKeyElement;

                setTimeout(function() {
			        submitCredentialEx(loginElement, keyElement);
			    }, 10);
			}
			else
			    submitCredentialEx(loginElementsJSONObj.loginElements[i], xpathKeyElement);

			xpathKeyElement = loginElementsJSONObj.loginElements[i].xPath;
		}
	}
	catch(err) {
		retObject.msg = 'Android_playback: Error occurred: ' + err.message;
	}

	AndroidCallback.playbackCompleted(JSON.stringify(retObject));
    gPlaybackDone = true;

	// If Ajax, need to trigger next page navigation (onFinalPageFinished)
	if (gHandlePlaybackAsAjax || hasNotifyOnSubmit) {
	  	myalert("Document location change after playbackCompleted");
	    document.location = "cgps:onPageSubmitted:" + window.location.href;
	}

	return;
}

//Wrapper functions for to return loginElements in custom-format.
//TODO: Eliminate need for this, and use Json object
//function Android_getAllLoginElements()
//{
//	android_alert('Android_getAllLoginElements');
//	if (isPasswordInPage() == "1") {
//		AndroidCallback.setLoginElements(getAllLoginElements());
//	}
//}

function GetPageCoords (element) {
	var coords = { x: 0, y: 0 };
	while (element) {
		coords.x += element.offsetLeft;
		coords.y += element.offsetTop;
		element = element.offsetParent;
	}
	return coords;
}

function setCCVal(ccValue)
{
	myalert('Setting : ' + ccValue);
	currCreditCardVal = ccValue;

	// When a value is set, de-select current active input element, so the keyboard can
	// be dismissed.
	// Causes crash on Select elements.... see setElementValue()
	//document.activeElement.blur();
}

function addOnFocusListeners()
{
	for (var j = 0; j < document.forms.length; j++ )
	{
		for (var i = 0; i < document.forms[j].elements.length; i++ )
		{
			var ele = document.forms[j].elements[i];

			var eleTagName = ele.tagName;
			if (eleTagName) {
				eleTagName = eleTagName.toUpperCase();
			}

			var eleType = ele.type;
			if (eleType) {
				eleType = eleType.toLowerCase();
			}

			if ( (
					(eleTagName == "INPUT") && (eleType != "hidden")  &&
					((eleType == "text") ||  (eleType == "password") ||
				 	(eleType == "checkbox") || (eleType == "radio") || (eleType == "email") || (eleType == "tel"))
				 )
					||
				 (
				 	(eleTagName == "SELECT") && (eleType != "hidden")
				 )
				)
			{
				//myalert('Target Tag is: ' + eleTagName + ' and Target Type is: ' + eleType);

				try
				{
					ele.addEventListener('click', setElementValue, false);
					ele.addEventListener('focus', setElementValue, false);

					if ((eleTagName == "SELECT") && (eleType != "hidden")) {
						myalert('Select type: Adding listener for change event');
						ele.addEventListener('focus', setElementValue, false);
					}
				}
				catch(e)
				{
					myalert('Got exception' + e.message);
				}
			}
		}
	}
}

function setElementValue(e)
{
	myalert('Setting value' + currCreditCardVal);

	if (!isEmpty(currCreditCardVal))
	{
		// This crashes. Select tag doesn't respond to a blur() event. And, on top of it crashes without throwing
		// exception
		/*try {
			if (!document.activeElement) {
				myalert('document.activeElement is null');
			} else {
				document.activeElement.blur();
			}
		} catch(ee) { myalert('Exception activeElement onBlur: ' + ee.message);} */

		var targ;

		if (!e)
		{
			e = window.event;
		}

		if (e.target) 	{
			targ = e.target;
		}
		else if (e.srcElement) {
			targ = e.srcElement;
		}

		if (!targ) {
			myalert('Target element is null. Returning...');
			return;
		}

		var targTagName = targ.tagName;
		if (targTagName) {
			targTagName = targTagName.toUpperCase();
		}

		// Drop-down element handling
		if (targTagName == "SELECT")
		{
			try
			{
				var optionsArr = targ.options;
				var optionVal;

				// HTML always returns values as text.
				if (optionsArr.length > 2)
				{
					// Get the 2nd item. 'cos the first item is sometimes "Select value" kind of help text.
					// Skip it.
					optionVal = targ.options[1].value;
					myalert('Option Val used is:' + optionVal);
				} else {
					optionVal = targ.options[0].value;
				}

				// Find the indexOf value in optionsArr
				var idx = indexInArray(optionsArr, currCreditCardVal);
				/*myalert('Array length: ' + optionsArr.length);

				var dbg = "";
				for (var k = 0; k < optionsArr.length ; k++) {
					dbg = dbg + optionsArr[k].value + ' ';
				}
				myalert('Array : ' + dbg);
				*/

				// Do regex checks - applicable mostly only for credit card dropdown options.

				// If dealing with the month field.
				if (currCreditCardVal.length == 2)
				{
					// if 1st dropdown option value format is 1-digit "x" -> then Month in int format.
					// Still returned as a string though.
					var regexD = /^\d{1}$/;

					// if 1st dropdown option value format is 2-digit "xx" -> then Month in string format.
					// This is default. leave as is.
					// var regexDD = /^\d{2}$/;

					// if 1st dropdown option value format is "Jan" -> then Month in short month format.
					var regexSM = /^Jan$/;

					// if 1st dropdown option value format is "January" -> then Month in long month format.
					var regexLM = /^January$/;

					// Check for int format
					if (regexD.test(optionVal))
					{
						// Set the value like an int
						targ.value = Number(currCreditCardVal);
					}
					else if (regexSM.test(optionVal))		// For short month format
					{
						var monthsShort = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
						targ.value = monthsShort[Number(currCreditCardVal) - 1];	// 0-based index.

					}
					else if (regexLM.test(optionVal))		// for long month format
					{
						var monthsLong = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
						targ.value = monthsLong[Number(currCreditCardVal) - 1];	// 0-based index.
					}
					else  // default. Set text as is.
					{
						targ.value = currCreditCardVal;
					}
				}
				else if (currCreditCardVal.length == 4) // 4 digit year
				{
					// For year, 2012 is the same as "2012" -> JS is loosely-typed.
					// So setting value to 2012 is same as setting it to "2012".
					try {
						myalert('Target Tag is: ' + targTagName + ' and Target Type is: ' + targ.type + ' Setting Year Val: ' + currCreditCardVal + ' Index is: ' + idx);

						//targ.selectedIndex = idx;
						//targ.focus();
						targ.value = currCreditCardVal;

						// blur() on a Select element crashes the app.
						//try {
						//	targ.blur();
						//	myalert('Setting blur');
						//}
						//catch(err) { myalert('Err: ' + err.message); }
					} catch (err) {
						myalert('Exception occurred setting value in target element: ' + currCreditCardVal);
					}
				}
			}
			catch (err) { }
		}
		else {
			// These are Input TAGs
			targ.focus();
			targ.value = currCreditCardVal;
			try {
				targ.blur();
				myalert('Setting document body focus');
			}
			catch(err) { }
		}

		var xpath = getElementXPath(targ);

		// Navigate to fake location. Obj-C layer intercepts the call and looks for token 'ccdemo', and should
		// prevent navigation.
		var coord = GetPageCoords(targ);

		document.location = "ccdemo:" + xpath + "||" + currCreditCardVal + "||" + coord.x + "||" + coord.y;

		// Reset the currCreditCardVal. User will need to select field again if required.
		currCreditCardVal = "";
	}
}

function findValueForKey(inpString, keyword)
{
	var retStr;

	if (inpString.search(keyword) != -1)
	{
		var tarr = inpString.split("=");

		if (tarr.length > 1)
		{
			retStr = tarr[1];
		}

		// Trim
		retStr = trim(retStr);
		retStr = retStr.replace(/^'|'$/g,"");
	}

	return retStr;
}

// Generate XPath for a given element
function getElementXPath(elt)
{
	var path = "";

	//myalert('getElementXPath');

	for (; elt && elt.nodeType == 1; elt = elt.parentNode)
	{
		var temp = "";
		var addAnd = false;

		//if (!(typeof elt.type == "undefined") && (elt.type !== ''))
		var tmpAttr = elt.getAttribute('type');
		if (!isBlank(tmpAttr))
		{
			temp += "@type = '" + tmpAttr + "'";
			addAnd = true;
		}

		//if (!(typeof elt.id == "undefined") && (elt.id !== ''))
		tmpAttr = elt.getAttribute('id');
		if ( (!isBlank(tmpAttr)) && (tmpAttr.search("'") == -1) )
		{
			if (addAnd) {
				temp += " and ";
			}
			temp +=  "@id = '" + tmpAttr + "'";
			addAnd = true;
		}

		//if (!(typeof elt.name == "undefined") && (elt.name !== ''))
		tmpAttr = elt.getAttribute('name');
		if ( (!isBlank(tmpAttr)) && (tmpAttr.search("'") == -1) )
		{
			if (tmpAttr.search("'") != -1) {
				tmpAttr = tmpAttr.replace(/'/g, "''");
			}

			if (addAnd) {
				temp += " and ";
			}
			temp +=  "@name = '" + tmpAttr + "'";
		}

		if (temp) {
			xname = elt.tagName + "[" + temp + "]";
		} else {
			idx = getElementIdx(elt);

			xname = elt.tagName;
			if (idx > 1) {
				xname += "[" + idx + "]";
			}
		}

		path = "/" + xname + path;
	}

	//myalert('getElementXPath returning: ' + path);

	return path;
}

// Find element index
function getElementIdx(elt)
{
    var count = 1;
    for (var sib = elt.previousSibling; sib ; sib = sib.previousSibling)
    {
        if(sib.nodeType == 1 && sib.tagName == elt.tagName)
		{
			count++;
		}
	}

    return count;
}

// Get the Document object for a given iframe/frame
function getDocumentForFrame(objIFrame)
{
	if (!objIFrame)
	{
		return null;
	}

	var currDocument;

	try {

		if (objIFrame.contentDocument)
		{
			currDocument = objIFrame.contentDocument;
			//myalert('got contentDocument');
		}
		else if (objIFrame.contentWindow)
		{
			currDocument = objIFrame.contentWindow.document;
			//myalert('got contentWindow');
		}
		else if (objIFrame.document)
		{
			currDocument = objIFrame.document;
			//myalert('got document');
		}
	}
	catch (err)
	{
		// Most probably, cross-domain kind of problem.
		myalert('Caught exeption getting document in frame: ' + err.message);
	}

	return currDocument;
}

// This tries to find a password element node in a given single Document object.
// Check explicitly for type='password' and ids & names that begin with 'pass'
function getPasswordNodeFromDoc(documentObj)
{
	var pwdNode;

	try
	{
		var pwdNodeList = documentObj.querySelectorAll("input[type='password'], input[id^='pass'], input[name^='pass']");
		if ((pwdNodeList) && (pwdNodeList.length > 0))
		{
			//myalert('Got password');
			pwdNode =  pwdNodeList[0];
		}
	}
	catch(err)
	{
		myalert('Failed to get password' + err.message);
	}

	return pwdNode;
}

// This tries to find a password element node in entire "page", including inside frames.
function getPasswordNodeFromPage()
{
	var pwdNode;
	try
	{
		// Check for type = password
		pwdNode = getPasswordNodeFromDoc(document);

		if (pwdNode)
		{
			return pwdNode;
		}

		// Else check thru frames.
		//myalert('Password not found in main document. Checking Frames: ' + window.frames.length);

		// Check frames.
		//for (var id in window.parent.frames)
		for (var id=0; id < window.frames.length; id++)
		{
			var oIframe = window.frames[id];
			var currDocument;

			currDocument = getDocumentForFrame(oIframe);
			if (currDocument)
			{
				//myalert('Checking Password in frame: ');
				pwdNode = getPasswordNodeFromDoc(currDocument);

				if (pwdNode) {
					//myalert('Password found in frame: ');
					return pwdNode;
				}
			}
		}
	}
	catch(err) { }

	return pwdNode;
}

// Checks if the page contains an input element of type "password"
// Used to decide if recording needs to be done - in single page trivial/non-trivial sites.
function isPasswordInPage()
{
	var pwdNode = getPasswordNodeFromPage();

	return (pwdNode) ? "1" : "0";
}

function setClassAttributes(element, disableClassNames, enableClassNames)
{
    if (element == null)
        return;

    if (disableClassNames == null)
        disableClassNames = "";

    if (enableClassNames == null)
        enableClassNames = "";

    var actualClass = element.getAttribute("class");
    var updatedClass = actualClass;

    if (updatedClass == null)
        updatedClass = "";

    var classNames = disableClassNames + " " + enableClassNames;
    classNames = classNames.trim();

    // Delete all class names that matches the given enable or disable classes.
    if (classNames.length > 0)
    {
        var classValues = updatedClass.split(" ");
        for (var i = 0; i < classValues.length; i++)
        {
            if (classNames.indexOf(classValues[i]) < 0)
                continue;

            myalert("setClassAttributes:: Deleting class attribute " + classValues[i]);
            updatedClass = updatedClass.replace(classValues[i], "");
        }
    }

    // Add the enable class names to the element.
    if (enableClassNames.length > 0)
    {
        myalert("setClassAttributes:: Adding class attributes " + enableClassNames);
        updatedClass += " " + enableClassNames;
    }

    // Update the class attribute if the class names are updated.
    if (updatedClass != actualClass)
        element.setAttribute('class', updatedClass);
}

// Playback Main Method
//
//
// Basic method to submit a value. If inputType == submit, then behavior is a bit different
function submitCredentialEx(loginElement, xpathKeyElement)
{
    var xpath = loginElement.xPath;
    var value = loginElement.xPathValue;
	var inputType = loginElement.inpType;

	myalert('submitCredentialEx: ' + xpath + ' value: ' + value + ' inputType: ' + inputType + ' disableClassNames: ' + loginElement.disableClassName + ' enableClassNames: ' + loginElement.enableClassName);

	var retString = "";
	var retNodeObj;

	//
	try {
		retNodeObj = findNodeForXPath(xpath);
	}
	catch(err)
	{
		msg = "submitCredentialEx: exception thrown from findNodeForXPath: " + err.message;
		return {"status":"fail", "msg":msg};
	}

	// Get the node
	var node = retNodeObj.node;
	var retObj = retNodeObj.obj;

	retObj.status = "fail";
	retObj.xPathValue = value;

	//myalert('submitCredentialEx: getting ready 1');

	inputType = inputType.toLowerCase();
	var retInputType = retObj.inpType.toLowerCase();

	if (node)
	{
		//myalert('submitCredentialEx: getting ready 2');

		// Zhuo
		if (node.hasAttribute("disabled")===true) {
            node.removeAttribute("disabled");
        }

		// Check both - inputType passed in and what we get from element node using xPath.
		if ( (inputType == "submit") || ( (retInputType == "submit") || (retInputType == "image") ))
		{
			//myalert('submitCredentialEx: getting ready 3');

			var targTagName;

			if (node.tagName) {
				targTagName = node.tagName.toUpperCase();
			}

			//myalert('submitCredentialEx: getting ready 4' + targTagName);

			var targType;
			if (node.type) {
				targType = node.type.toLowerCase();
			}

            disabled = node.getAttribute("disabled")
            myalert("What is disabled ? " + disabled);
            if (disabled == "disabled")
            {
                myalert('Removing attributes {disabled} for Submit element');
                node.setAttribute('disabled', "none");
            }

            if (loginElement.disableClassName == null || loginElement.disableClassName.length == 0)
                loginElement.disableClassName = "disabled";

            /*
            className = node.getAttribute("class");
            myalert("What is className ? " + className);
            if (className != null)
            {

                var disableClasses = disableClassNames.split(" ");
                for (var j = 0; j < disableClasses.length; j++)
                {
                    var disableClass = disableClasses[j];

                    values = className.split(" ");
                    for (var i = 0; i < values.length; i++)
                    {
                        if (disableClass != values[i])
                            continue;

                        myalert('Removing class attributes " + values[i] + " for Submit element');

                        className = className.replace(values[i], "btnDis");
                        node.setAttribute('class', className);
                        break;
                    }
                }
            }
            */

            setClassAttributes(node, loginElement.disableClassName, loginElement.enableClassName);

			myalert('Target Tag is: Type is :' + targTagName + '---' + targType);

			// Handle well-known cases dispatching click events. All other cases, do form submit
			// Ignore the 'value' argument. Try and set focus, and then invoke a click.
			try {
				node.focus();
			}
			catch(err)
			{
				// Do nothing if focus failed. Try to send click directly.
			}

			retObj.status = "success";

			try {
				//myalert('submitCredentialEx: onClick');

				if (targTagName == "INPUT" && targType == "password")
                {
                     myalert('submitCredentialEx: special handling for missing submit element');
                     AndroidCallback.emulateSubmitEnterKey();
				}
				else
				    node.onClick();
			}
			catch(err)
			{
				// If click failed, try onclick...
				try {
					myalert('submitCredentialEx: click');
					node.click();
				}
				catch(err)
				{
					// If that failed too, dispatch a click event
					try {

						if(document.dispatchEvent) { // W3C
							myalert('submitCredentialEx: MouseEvents');

							var oEvent = document.createEvent( "MouseEvents" );
							//oEvent.initMouseEvent("click", true, true,window, 1, 1, 1, 1, 1, false, false, false, false, 0, node);
							oEvent.initMouseEvent("click", true, true,window, 1, 1, 1, 1, 1, false, false, false, false, 0, null);
							node.dispatchEvent( oEvent );
						}
						else if(document.fireEvent) { // IE
							myalert('submitCredentialEx: fireEvent');
							node.fireEvent("onclick");
						}
					}
					catch(err)
					{
						try {
							// Do a form submit
							myalert('submitCredentialEx: Form submit');
							node.form.submit();
						}
						catch(err)
						{
							try
							{
								//
								var retNodeObjKey = findNodeForXPath(xpathKeyElement);

								// Get the node
								var keyNode = retNodeObjKey.node;

								if (keyNode)
								{
									myalert('submitCredentialEx: Doing Form submit based on Key Element(uid or pwd) Node');
									keyNode.form.submit();

									retObj.status = "success";
								}
							}
							catch (err)
							{
								msg = "submitCredentialEx: exception thrown from findNodeForXPath finding Key Element(uid or pwd): " + err.message;
								myalert('caught exception' + msg);

								retObj.status = "fail";
								retObj.msg = msg;

							}
						}
					}
				}
			}
		}
		else
		{
			// For userid, password and other fields (excl submit)
			// Set focus, set value (needs to be keystrokes, maybe), and then lose focus to trigger any
			// onblur event that this element may have.
			try {
				//myalert('SubmitCredentialEx: setting value');

				node.focus();
				node.value = value;

				try {
					node.blur();
				}
				catch(err) { }

				retObj.status = "success";
			}
			catch(err)
			{
				retObj.msg = "submitCredentialEx: Failed to set value";
			}
		}
	}
	else
	{
		// Node was not found for some reason - id was wrong or does not exist, name was null or whatever.
		// If the element being searched for was a submit element, then check if the xpath has a formname embedded in the
		// string (trivial algorithm puts it in there. Non-trivial will not have it)
		if ((inputType == "submit") || ( (retInputType == "submit") || (retInputType == "image") ))
		{
			// Use the password element's xpath and do a submit on its form.
			try
			{
				//
				var retNodeObjKeyLast = findNodeForXPath(xpathKeyElement);

				// Get the node
				var keyNodeLast = retNodeObjKeyLast.node;

				if (keyNodeLast)
				{
					var stillNoSuccess = true;

					/*
					// Before doing a form submit, attempt to find a unique submit element in the
					// login form, based on leaf node attribute of submit element xPath.
					try
					{
						// Get leaf node from submit element xPath
						var xarray = xpath.split("/");
						// Pop the leaf node element out.
						var leafNodeElementStr = xarray.pop();

						var formSubmitNodes = keyNodeLast.form.querySelectorAll(leafNodeElementStr);
						if (formSubmitNodes.length == 1)
						{
							// Got a unique element within this form. Use it.
							try {
								alert('submitCredentialEx: click on formSubmitNode');
								formSubmitNodes[0].click();
								stillNoSuccess = false;
							}
							catch(err1)
							{
								// If that failed too, dispatch a click event
								try {
									if(document.dispatchEvent) { // W3C
										myalert('submitCredentialEx: MouseEvents');

										var oEvent = document.createEvent( "MouseEvents" );
										oEvent.initMouseEvent("click", true, true,window, 1, 1, 1, 1, 1, false, false, false, false, 0, null);
										formSubmitNodes[0].dispatchEvent( oEvent );

										stillNoSuccess = false;
									}
								}
								catch(err2)
								{
								}
							}
						}
					}
					catch (err) { }
					*/

					if (stillNoSuccess)
					{
						myalert('submitCredentialEx: Finally doing Form submit based on Key Element(uid or pwd) Node');
						keyNodeLast.form.submit();
					}

					retObj.status = "success";
				}
			}
			catch (err)
			{
				msg = "submitCredentialEx: exception thrown from final findNodeForXPath finding Key Element(uid or pwd): " + err.message;
				retObj.status = "fail";
				retObj.msg = msg;
			}
		}
	}

	try
	{
		retString = JSON.stringify(retObj);
	}
	catch(err)
	{
		//myalert ('JSON returned:' + err);
		retString = '{"status" : "' + retObj.status + '", "rank" : "' + retObj.rank + '", "msg" : "' + retObj.msg +'", "inpType" : "' + retObj.inpType +'", "attType" : "' + retObj.attType + '", "attValue" : "' + retObj.attValue + '", "xPathValue" : "' + retObj.xPathValue + '"}';
	}

	myalert(retString);

	return retString;
}

function getSubmitElement(form)
{
    myalert("Entering getSubmitElement ");

    var submitElement = null;
    if (form == null)
        return false;

	for (var i = 0; i < form.length; i++ )
	{
		var element = form[i];
        myalert("getSubmitElement: tag: " + element.tagName + " Type: " + element.type);

		if (element == null || element.tagName == null || element.type == null)
		    continue;

		if (element.type.toLowerCase() != "submit")
		    continue;

        myalert("getSubmitElement2: tag: " + element.tagName + " Type: " + element.type);

    	submitElement = element;
		break;
	}
    return submitElement;
};

// This is to track the Submit button - used in Non-Trivial cases where we do not have 2nd Page xPath info.
// Add click event
function _dom_trackSubmitButton()
{
	/*
	// Don't re-use document.activeElement. If supported, sometimes doesn't show expected value. If not supported, setting
	// values into this element does not work sometimes (read-only?)
	// if (!document.activeElement)
	// {
	if (document.addEventListener) 			// DOM-2 supports this
	{
		// false means, 'bubbling'. ie., events are 'captured' by the parent elements until it reaches the target element
		// which are then 'bubbled' back to the parent. Here, we are adding listener to the document object itself (maybe
		// we should add events to specific element types (submit button, input types etc...).
		// Last parameter true or false, should
		// in theory return the same value for target/srcElement, which should be the element click happened on.
		document.addEventListener('click', _dom_trackActiveElement, false);
		//document.addEventListener('mousedown', _dom_trackActiveElement, false);
	}
	else if (document.attachEvent) 		// IE
	{
		document.attachEvent('click', _dom_trackActiveElement);
		//document.attachEvent('onmousedown', _dom_trackActiveElement);
	}
	//}
	*/

	// Capture the onfocus() event during "Capturing" phase. Most browsers do not "bubble" back onfocus() and onblur()
	// events since it does not make sense for elements above the visible element to handle onfocus() and onblur()...generally
	//
	if (document.addEventListener) 			// DOM-2 supports this
	{
		document.addEventListener('focus', _dom_trackActiveElement, true);
		document.addEventListener('click', _dom_trackActiveElement, true);
	}
	else if (document.attachEvent) 		// IE
	{
		document.attachEvent('focus', _dom_trackActiveElement);
		document.onfocusin = _dom_trackActiveElement;
	}
	//}

	// Also add the event to all documents inside frames.
	//for (var id in window.parent.frames)
	for (var idx = 0; idx < window.frames.length; idx++)
	{
		var oIframe = window.frames[idx];

		var currDocument = getDocumentForFrame(oIframe);
		if (currDocument)
		{
			if (currDocument.addEventListener) 			// DOM-2 supports this
			{
				currDocument.addEventListener('focus', _dom_trackActiveElement, true);
				currDocument.addEventListener('click', _dom_trackActiveElement, true);
			}
			else if (currDocument.attachEvent) 		// IE
			{
				currDocument.attachEvent('focus', _dom_trackActiveElement);
				currDocument.onfocusin = _dom_trackActiveElement;
			}
		}
	}
}

// Track the submit element (last element that got a click before user navigated out of the page - this could be
// a non-submit link too (not foolproof)
// Identify the element and set its value in a hidden field. get2ndPageSubmitElement() is called from obj-C wrapper
// to retrieve this element.
//
// Need to get the element that originated the event (ie. object that fired the event)
// not the one that intercepted it...
function _dom_trackActiveElement(e)
{
	var targ;

	//myalert('In _dom_trackActiveElement');

	if (!e)
	{
		e = window.event;
	}

	if (e.target) 	{
		targ = e.target;
	}
	else if (e.srcElement) {
		targ = e.srcElement;
	}

	if (targ.nodeType == 3) { // defeat Safari bug
		targ = targ.parentNode;
	}

	//
	if (targ.type == "hidden")
	{
		return;
	}

	var targTagName = targ.tagName;
	if (targTagName) {
		targTagName = targTagName.toUpperCase();
	}

	var targType = targ.type;
	if (targType) {
		targType = targType.toLowerCase();
	}

	// Don't bother with input elements of these types. We are looking for submit elements.
	if ( (targTagName == "INPUT") && ((targType == "text") ||  (targType == "password") ||
										(targType == "checkbox") || (targType == "radio") || (targType == "email") || (targType == "tel")) )
	{
		return;
	}

	// This setting is not used. Caller can directly use this instead of the hidden element below...maybe
	//document.activeElement = targ;
	try
	{
		var elAttrObj = getElementAttributes(targ);
		if ( (isBlank(elAttrObj.type)) || (elAttrObj.type != "IMAGE") ) {
			elAttrObj.type = "submit";
		}

		var attrVal = 'inpType:' + elAttrObj.type + '::xPath:' + elAttrObj.xPath + '::xPathValue:' + elAttrObj.xPathValue;

		//myalert('Got this data ' + attrVal);

		/*
		// Add a hidden element if it doesn't already exist. And then set its attributes
		var actElem = document.getElementById('cgwsps_hid1');
		if (!actElem)
		{
			// Create a new one...
			var newActElem = document.createElement('div');

			newActElem.setAttribute('id', 'cgwsps_hid1');
			newActElem.setAttribute('type', 'hidden');
			newActElem.setAttribute('value', attrVal);

			document.body.appendChild(newActElem);
		}
		else
		{
			// Update the value
			actElem.value = elVal;
		}
		*/

		// appendChild added to DOM is not available immediately
		// Instead, assign to page level var and access later.
		submitEl2ndPage = attrVal;			// assign to page level var

		//myalert('_dom_trackActiveElement: Submit node value is: ' + submitEl2ndPage);

	}
	catch (err)
	{
		myalert('Exception in _dom_trackActiveElement: ' + err.message);
	}
}

// Merely returns the submit element (hidden cgwsps_hid1) in JSON format
function get2ndPageSubmitElement()
{
	// Return Object - init
	var retObj = {status:"fail", rank:"0", msg:"None", inpType:"", xPath:"", xPathValue:""};

	try {
		/*
		var node = document.getElementById('cgwsps_hid1');

		// If found, this will be of format 'xpath:val1::leafNode:val2'
		// So, first split by '::', then by ':'
		if (node)
		{
			myalert('2ndPage Submit node value is: ' + node.value);

			var mainArr = node.value.split("::");
		*/

		// Parse submitEl2ndPage and return JSON object as string
		if (submitEl2ndPage)
		{
			//myalert('2ndPage Submit node value is: ' + submitEl2ndPage);

			var mainArr = submitEl2ndPage.split("::");

			if (3 === mainArr.length)
			{
				retObj.status = "success";

				// Should have 3 elements in array.
				var tmpArr1 = mainArr[0].split(":");
				if (!isEmpty(tmpArr1[1])) {
					retObj.inpType = tmpArr1[1];
				} else {
					retObj.inpType = "submit";			// Check !!!
				}

				// Get val2
				var tmpArr2 = mainArr[1].split(":");
				if (!isEmpty(tmpArr2[1])) {
					retObj.xPath = tmpArr2[1];
				}

				var tmpArr3 = mainArr[2].split(":");
				if (!isEmpty(tmpArr3[1])) {
					retObj.xPathValue = tmpArr3[1];
				}
			}
			else
			{
				retObj.msg = "submitEl2ndPage not in correct format. Expected 2 tokens. " + submitEl2ndPage;
			}
		}
	} catch(err) { }

	// Return whatever we have.
	retString = JSON.stringify(retObj);

	myalert('get2ndPageSubmitElement returned:\n' + retString);

	return retString;
}

// 2nd Page credentials. Get the Password field's leafnode paths (inpType, attType, attValue) and its value (in the
// case of Password field. Also, get the Submit buttons attributes (value not required)
function get2ndPagePassword()
{
	// Return Object - init
	var retObj = {status:"fail", rank:"0", msg:'', inpType:'', xPath:'', xPathValue:''};

	// Just get the first one. It is possible that multiple input fields with type = password exist on this page.
	// This is the 2nd page in a 2-page non-trivial site. So, chances are low for multiple password fields.
	var pwdNode = getPasswordNodeFromPage();

	if (pwdNode)
	{
		//myalert('get2ndPagePassword: calling getElementXPath');

		var elXPath = getElementXPath(pwdNode);

		retObj.inpType = "password";
		retObj.xPath = elXPath;
		retObj.xPathValue = pwdNode.value;

		retObj.status = "success";
	}
	else {
		myalert('pwdNode is null');
		retObj.msg = "Password element not found in second page";
	}

	// Return whatever we have.
	retString = JSON.stringify(retObj);
	myalert('get2ndPagePassword returned:\n' + retString);

	return retString;
}

// This is used to get all the elements captured using Trivial algorithm.
// Return loginElements Array as string
// Add the first submit element, followed by input elements, and finally the final submit
function getAllLoginElements()
{
	var retStr = "";

	// Check # of elements in submit array.
	var submitcount = Object.size(loginElementsArray_Submit);

	var inputcount = Object.size(loginElementsArray_Input);

	if ( (submitcount == 0) && (inputcount == 0) ) {
		return retStr;
	}

	//myalert('Submit count: ' + submitcount + ' and inputcount: ' + inputcount);

	if (submitcount > 1)
	{
		for (key in loginElementsArray_Submit)
		{
			if (loginElementsArray_Submit.hasOwnProperty(key))
			{
				if (key === firstSubmitKey)
				{
					retStr += loginElementsArray_Submit[key]  + ",";
				}
			}
		}
	}
	// Add the input elements
	for (keyInp in loginElementsArray_Input)
	{
		if (!(loginElementsArray_Input.hasOwnProperty(keyInp)))
		{
			continue;
		}

		retStr += loginElementsArray_Input[keyInp]  + ",";
	}

	// Finally, add the final submit element (not equal to the first submit key)
	for (key in loginElementsArray_Submit)
	{
		if (loginElementsArray_Submit.hasOwnProperty(key))
		{
			if ( (key !== firstSubmitKey) || (submitcount === 1) )
			{
				retStr += loginElementsArray_Submit[key]  + ",";
			}
		}
	}

	myalert ('getAllLoginElements returned: ' + retStr);

	return retStr;
}

// Add click event
function _dom_trackOnFocus()
{
	// Capture the onfocus() event during "Capturing" phase. Most browsers do not "bubble" back onfocus() and onblur()
	// events since it does not make sense for elements above the visible element to handle onfocus() and onblur()...generally
	//
	if (document.addEventListener) 			// DOM-2 supports this
	{
	    document.addEventListener('blur', handleOnBlur, true);
		document.addEventListener('focus', _dom_trackOnBlur, true);
		document.addEventListener('click', _dom_trackOnBlur, true);
		// document.onmouseover = _dom_trackOnFocus;
	}
	else if (document.attachEvent) 		// IE
	{
		document.attachEvent('focus', _dom_trackOnBlur);
		//document.attachEvent('onmousedown', _dom_trackOnFocus);
		document.onfocusin = _dom_trackOnFocus;
	}
	//}

	// Also add the event to all documents inside frames.
	//for (var id in window.parent.frames)
	for (var idx = 0; idx < window.frames.length; idx++)
	{
		var oIframe = window.frames[idx];

		var currDocument = getDocumentForFrame(oIframe);

		if (currDocument)
		{
			if (currDocument.addEventListener) 			// DOM-2 supports this
			{
			    currDocument.addEventListener('blur', handleOnBlur, true);
				currDocument.addEventListener('focus', _dom_trackOnBlur, true);
				currDocument.addEventListener('click', _dom_trackOnBlur, true);
				// document.onmouseover = _dom_trackOnFocus;
			}
			else if (currDocument.attachEvent) 		// IE
			{
				currDocument.attachEvent('focus', _dom_trackOnBlur);
				//document.attachEvent('onmousedown', _dom_trackOnFocus);
				currDocument.onfocusin = _dom_trackOnFocus;
			}
		}
	}
}

/*
 For Tag = <INPUT>, valid types are:
		"button, checkbox, file, hidden, image, password, radio, reset, submit, text"

 The Tag could also be a "BUTTON". Valid types for this tag are:
 			button			(type can also be 'button')
 			reset
 			submit

 The Log In button can be :
 	1: <INPUT type = 'button'..>
 	2: <INPUT type = 'submit'...>
 	3: <BUTTON type = 'button' ...>
 	4: <BUTTON type = 'submit' ...>
 	5. <IMG
*/

function _dom_trackOnBlur(e)
{
	var targ;

	if (!e)
	{
		e = window.event;
	}

	if (e.target) 	{
		targ = e.target;
	}
	else if (e.srcElement) {
		targ = e.srcElement;
	}

	if (targ.nodeType == 3)  { // defeat Safari bug
		targ = targ.parentNode;
	}

	// unlikely condition
	//if (targ.type == "hidden")
	if (targ.type == "hidden")
	{
		return;
	}

	if (targ.type != "submit" && targ.children.length > 0)
	{
		return;
	}

	var targTagName = targ.tagName;
	if (targTagName) {
		targTagName = targTagName.toUpperCase();
	}

	var targType = targ.type;
	if (targType) {
		targType = targType.toLowerCase();
	}

	//myalert('Target Tag is: ' + targTagName + ' and Target Type is: ' + targType);

	if ( (targTagName == "INPUT") && ((targType == "text") ||  (targType == "password") ||
										(targType == "checkbox") || (targType == "radio") || (targType == "email") || (targType == "tel")) )
	{
		myalert('Got input/img tag');

		// Add onblur listener to this element.
		//if (targ.addEventListener)
		//	targ.addEventListener('blur',handleOnBlur,true);
		//else if (targ.attachEvent)
		//	targ.attachEvent('blur', handleOnBlur);
	}
	else
	{
		var elAttrObj = getElementAttributes(targ);
		// Set this to 'submit' type regardless. ex: Nordstormcard has type = BUTTON..

		if ( (isBlank(elAttrObj.type)) || (elAttrObj.type != "IMAGE") ) {
			elAttrObj.type = "submit";
		}

		var attrVal = 'inpType:' + elAttrObj.type + '::xPath:' + elAttrObj.xPath + '::xPathValue:' + elAttrObj.xPathValue;

		myalert('Target Tag is: ' + targTagName + ' Blur got: ' + attrVal);

		// If not the target element and is part of bubble/capture, ignore it. We are interested only
		// in the leaf-node element.
		// Checking here if childNodes length is > 1.
		// TODO: Using > 1 condition here, since the submit element
		// can have a title that is also an element. Need to ensure this holds in all cases.
		// ActiveElement does not work - Points to element that is the "current listener" not just the element
		// that got the user click-event.
		//if (document.activeElement)
		if (targ.type != "submit" && targ.childNodes.length > 1 )
		{
			myalert(' Not an end node');
			return;
		}
		// Generate unique key based on full xPath.
		//var key = genKey(targ.tagName, elAttrObj.type, targ.id, targ.name);
		var key = genKeyXPath(elAttrObj.xPath);

		key = "ZZSubmit" + key;

		//loginElementsArray[key] = attrVal;
		loginElementsArray_Submit[key] = attrVal;

		// IF not set till now, set it. This is the first submit key.
		if (isBlank(firstSubmitKey)) {
			firstSubmitKey = key;
		}

		// Call back into Android app
	    if ( (siteIsTrivial == "1") || (siteIsTrivial == "true") ) {
		    Android_callbackForTrivial();
		}
	}
}

function handleOnBlur(el)
{
  	// Use local scope just in case.
	//that=this;
	that = el.target;

    var targTagName = that.tagName.toUpperCase();
    var targType = that.type.toLowerCase();
 	var searchString = "text password checkbox radio email tel";

	if (targTagName != "INPUT" || searchString.indexOf(targType) == -1)
	    return;
	myalert('Handle on blur Value: ' + that.value );

	// The this pointer should  be pointing to the element itself.
	var elAttrObj = getElementAttributes(that);
	//var elAttrObj = getElementAttributes(el);

	var attrVal = 'inpType:' + elAttrObj.type + '::xPath:' + elAttrObj.xPath + '::xPathValue:' + elAttrObj.xPathValue;

	myalert('Blur got: ' + attrVal);

	var key = genKey(that.tagName, elAttrObj.type, that.id, that.name);

	myalert('Generated Key is: ' + key );

	//loginElementsArray[key] = attrVal;
	loginElementsArray_Input[key] = attrVal;
}

function genKey(tagName, type, id, name)
{
	var concat = tagName + '_' + type + id + name;

	//myalert('Input params for key:' + concat);

	// strip out special characters and replace with '_'. Here, ^ => 'not'. So, replace any char that is not alphanumeric
	concat =  concat.replace(/[^a-zA-Z0-9]+/g,'_');

	//myalert('Returning key:' + concat);

	return concat;
}

function genKeyXPath(xpath)
{
	// First get the simplified version and then get rid of special characters.
	// find all characters to end of line starting from '[' (open square bracket)
	var srch = new RegExp("\\[.*");
	//var srch = /\[.*/;

	var xarray = xpath.split("/");

	// Pop the leaf node element out.
	var leafNodeElement = xarray.pop();

	var key = '';
	// xarray does not contain the leaf node now - has been popped out.
	for (i=0; i<xarray.length;i++)
	{
		if (isEmpty(xarray[i]))
		{
			continue;
		}
		// strip all characters starting from '['
		sub = xarray[i].replace(srch, "");

		key = key + sub;			// don't put the "/" here
	}

	// Get rid of all special characters
	leafNodeElement2 = leafNodeElement.replace(/[^0-9a-zA-Z]/gi, '');

	//myalert("genKeyXPath: Leaf node after is: " + leafNodeElement2);

	key = key + leafNodeElement2;

	//myalert('Returning key:' + key);

	return key;
}

function getElementAttributes(el)
{
	var elXPath = getElementXPath(el);

	var elType = "";
	var elValue = "";

	var tmpAttr;
	try {
		//tmpAttr = el.getAttribute('type');
		tmpAttr = el.type;
		if (!isBlank(tmpAttr)) {
			elType = tmpAttr;
		}
	} catch (err) {}

	try {
		//tmpAttr = el.getAttribute('value');
		tmpAttr = el.value;
		if (!isBlank(tmpAttr)) {
			elValue = tmpAttr;
		}
	} catch (err) {}

	//myalert('elType: ' + elType + ' elXPath: ' + elXPath + ' elValue: ' + elValue);

	return {type:elType, xPath:elXPath, xPathValue:elValue};
}

//
function getValueForXPath(xpath)
{
	var retString = "";
	var success = "success";

	//myalert('Start');

	var retNodeObj = findNodeForXPath(xpath);

	// Get the node
	var retNode = retNodeObj.node;
	var retObj = retNodeObj.obj;

	if (retNode)
	{
		//myalert('Got a node out of retNode');

		// Find value of node and assign to return obj
		retObj.xPathValue = retNode.value;

		myalert('xPathValue is: ' + retObj.xPathValue);

		if (isEmpty(retObj.xPathValue) || retObj.xPathValue.indexOf("**") >= 0 || retObj.xPathValue.indexOf("..") >= 0)
		{
			myalert ('setting empty' + retObj.inpType + " type= " + retNode.type);
			retObj.xPathValue = "";

			if (retObj.inpType == "text" || retObj.inpType == "password")
			{
                var elAttrObj = getElementAttributes(retNode);
                var key = genKey(retNode.tagName, elAttrObj.type, retNode.id, retNode.name);

                if (loginElementsArray_Input.hasOwnProperty(key) == true)
                {
                    myalert("Key inp found " + key);

                    var values = loginElementsArray_Input[key].split("::");
                    if (values != null && values.length >= 3)
                    {
                        values = values[2].split(":");
                        if (values != null && values.length >= 2)
                            retObj.xPathValue = values[1];
                    }
                }
                myalert('xPathValue is: ' + retObj.xPathValue);
            }
		}

		retObj.status = success;
	}

	//myalert('Done');

	// Return whatever we have.
	retString = JSON.stringify(retObj);

	myalert(retString);

	return retString;
}

function findNodeForXPath(xpath)
{
	var retNode;

	// Return Object - init
	var retObj = {status:"fail", rank:"0", msg:"None", inpType:'', attType:'', attValue:'', xPathValue:''};

	try {
		// Strip out @src data - we can't handle "/" in xpath query, and we don't need it.
		var srcPattern = /\ and @src='.*'/;
		if (srcPattern.test(xpath))
		{
			xpath = xpath.replace(srcPattern, "");
		}
		else
		{
			srcPattern = /\@src='.*' and /;
			if (srcPattern.test(xpath))
			{
				xpath = xpath.replace(srcPattern, "");
			}
			else
			{
				srcPattern = /\@src='.*'/;
				if (srcPattern.test(xpath))
				{
					xpath = xpath.replace(srcPattern, "");
				}
			}
		}

		// 0. Parse leaf node and get input Type, attribute Type, and attribute Value
		retObj = parseForLeafNodeAttribs(xpath, retObj);

		myalert('Parse returned: ' + retObj.inpType + ',' + retObj.attType + ',' + retObj.attValue + ',' + xpath);

		// First try full xpath
		retObj.rank = 1;
		//myalert('Level 1: ');
		retNode = getNodeForFullXPath(xpath, document);
		if (!retNode)
		{
			//myalert('Level 2');

			// Try simplified xpath.
			retObj.rank++;
			retNode = getNodeForSimplifiedXPath(xpath, document);
		}
		if (!retNode)
		{
			//myalert('Level 3');
			// Try simplified xpath.
			retObj.rank++;
			retNode = getNodeByLeafNodeAttribs(retObj.attType, retObj.attValue, document);
			if (retNode == null)
			{
			    //myalert("Lets prepare a query for xPath =  " + xpath );
			    var query = "";
			    if (xpath.indexOf("BUTTON[@type = 'submit']") > 0)
			        query = 'button[type="submit"]';
			    else if (xpath.indexOf("INPUT[@type = 'submit']") > 0)
			        query = 'input[type="submit"]';

                //myalert("Got the query " + query);

			    if (query.length > 0)
			    {
			        //myalert("Attempting to find submit element using query selector. " + query);

			        retNode = document.querySelector(query);
			        if (retNode == null)
			        {
			            myalert("Failed to get the submit element by query selector.");
			        }
			    }
			}
		}

		// 4. Well, now what?? Maybe the login form is inside a frame. Iterate thru the documents frames.
		// getValueForXPath() can easily be called recursively for any level of nested frames
		// For now, limiting to only 1-level deep.
		if (!retNode)
		{
			//get elements in iframe documents
			//var all_IFrames = document.getElementsByTagName('iframe');
			var all_IFrames = window.frames; // Does not work for cross-domain sites.

			myalert('Total count of iFrames: ' + all_IFrames.length);

			var frame_len = all_IFrames.length;

			var ifdx = 0;
			//while ((oIframe = all_IFrames.item(ifdx)) != nil)
			//while ((oIframe = all_IFrames[ifdx]) != nil)

			for (ifdx = 0; ifdx < frame_len; ifdx++)
			{
				//ifdx++;
				var oIframe = all_IFrames[ifdx];

				var currDocument = getDocumentForFrame(oIframe);

				try {
					if (currDocument)
					{
						retObj.rank++;
						//myalert('Level 4: ' + oIframe.name);

						retNode = getNodeForFullXPath(xpath, currDocument);
						if (!retNode)
						{
							//myalert('Level 5');

							retObj.rank++;
							retNode = getNodeForSimplifiedXPath(xpath, currDocument);
						}
						if (!retNode)
						{
							//myalert('Level 6');

							// Try simplified xpath.
							retObj.rank++;
							retNode = getNodeByLeafNodeAttribs(retObj.attType, retObj.attValue, currDocument);
							//myalert('Done with level 6');
						}

						if (retNode)
						{
							//myalert('Breaking out of loop');
							break;
						}
					}
				}
				catch(err)
				{
					myalert('Exception occurred : ' + err.message);
				}
			}
		}
	}
	catch(err) { }

	return {node:retNode, obj:retObj};
}


function parseForLeafNodeAttribs(xpath, retObj)
{
	//myalert('parseForLeafNodeAttribs - before ' + xpath);

	// IF there are any @src elements, remove it - mostly are urls and the slashes mess up the split here.
	// May leave stray '|' around.
	/*
	var srcPattern = /\@src='.*'/;
	if (srcPattern.test(xpath))
	{
		xpath = xpath.replace(srcPattern, "@src=''");
	}
	*/
	//myalert('after ' + xpath);

	// Split xpath by '/' and Pop the leaf node element out. Example format: INPUT[@id = 'abc' or @name = 'def']
	var leafNodeElement = xpath.split("/").pop();

	// Replace '[' and ']' and " or " with "|", and then split the result string by '|'
	var yStr = leafNodeElement.replace("[", "|").replace("]", "|").replace(/ or /gi, "|").replace(/ and /gi, "|");
	//myalert('LeafNode after replace: ' + yStr);

	var zArr = yStr.split("|");

	var typeValue = "";
	// Get the type - we may need it.
	for (i=0; i<zArr.length;i++)
	{
		if (isEmpty(zArr[i]))
		{
			continue;
		}

		// Look for @type. TODO - use word boundaries in search ie  \b@type\b
		typeValue = findValueForKey(zArr[i], "@type");

		if (!isEmpty(typeValue))
		{
			break;
		}
	}

	// If empty, default
	if (isEmpty(typeValue))
	{
		typeValue = "text";
	}
	retObj.inpType = typeValue;

	// See if we got id or name
	var idValue = "";
	for (i=0; i<zArr.length;i++)
	{
		if (isEmpty(zArr[i]))
		{
			continue;
		}

		// Look for @id. TODO - use word boundaries in search ie  \b@id\b
		idValue = findValueForKey(zArr[i], "@id");

		if (!isEmpty(idValue))
		{
			break;
		}
	}

	// IF we got a value, return.
	if (!isEmpty(idValue))
	{
		// Build the output object
		retObj.attType = "id";
		retObj.attValue = idValue;

		return retObj;
	}

	// Id does not exist in attributes list.
	// In xPath from TN Service, either "id" exists or "name", not both!
	var nameValue = "";
	for (i=0; i<zArr.length;i++)
	{
		if (isEmpty(zArr[i]))
		{
			continue;
		}

		// Look for @name. TODO - use word boundaries in search ie  \b@name\b
		nameValue = findValueForKey(zArr[i], "@name");

		if (!isEmpty(nameValue))
		{
			break;
		}
	}

	// IF we got a value, return.
	if (!isEmpty(nameValue))
	{
		// Build the output object
		retObj.attType = "name";
		retObj.attValue = nameValue;

		return retObj;
	}

	// Return whatever we have now. Both checks may have failed...
	return retObj;
}

function getFormIdAndName(xpath)
{
	var formsArray = xpath.split("@cgforminfo = ");

	var forminfo;
	var idx = "";
	var namex = "";

	if (formsArray.length > 1)
	{
		forminfo = formsArray[1].replace(/]/,"");

		var id_name = forminfo.split("|");
		var regex2 = new RegExp("'");

		if (id_name.length > 0)
		{
			idx = id_name[0].replace(regex2, "");
		}

		if (id_name.length > 1)
		{
			namex = id_name[1].replace(regex2, "");
		}
	}

	return {Id:idx, Name:namex};
}


// Get Node (ie query based on) the full xpath.
function getNodeForFullXPath(xpath, thisDocument)
{
	var node;

	try {

		//var id_name = getFormIdAndName(xpath);

		// xPaths for trivial sites are generated (ie not from TN site). These may contain 'form' info inside
		// leaf-node predicate.
		// Get rid of cgforminfo and everything after that.
		//var xpathScrub = xpath.replace(/\|\| \@cgforminfo.*/, "]");

		// When we have multiple conditions in the predicate, use the "and" clause, not "or".
		// Replace all "||" with "and"
		xpathScrub = xpath.replace(/\|\|/g, " and ");

		// If first character is not "/" (like in /html/body...), then Trivial algorithm probably made the
		// call into this function. These may not have the full path and may contain only the leaf node details.
		// In this case, do a wild-card search - ie use a "//" as the prefix.
		if (!(xpathScrub.lastIndexOf("/", 0) === 0)) {
			xpathScrub = "//" + xpathScrub;
		}

		myalert('getNodeForFullXPath : ' + xpathScrub);

		// Find the element based off the xpath, inside the body
		var nodeList = null; //thisDocument.evaluate(xpathScrub, thisDocument.body, null, XPathResult.ANY_TYPE , null);
		if (nodeList == null)
		{
		    myalert("Let's try with UNORDERED_NODE_SNAPSHOT_TYPE...");
		    nodeList = thisDocument.evaluate(xpathScrub, thisDocument, null, window.XPathResult.ANY_TYPE, null);
		}

		if (nodeList)
		{
			node = nodeList.iterateNext();
			myalert( (node) ? 'getNodeForFullXPath : Got Node!!' : 'getNodeForFullXPath : Did not get a Node!!');

			/*while (node)
			{
				alert( node.textContent );
				node = nodeList.iterateNext();
			} */

		}
	}
	catch(err)
	{
	    myalert("getNodeForFullXPath(): Exception caught. " + err.message);
	}

	return node;
}

// This function takes a detailed xpath and removes all internal attributes leaving details for only leaf-node attribute
// Ex: /HTML/BODY/DIV/DIV[@id='main']/DIV[@id='right']/DIV[@id='login-panel']/DIV/INPUT[@id='ctlSignon_txtPassword']
// would become /HTML/BODY/DIV/DIV/DIV/DIV/INPUT[@id='ctlSignon_txtPassword']
// We are doing this 'cos sometimes internal attributes sometimes are generated...
function getNodeForSimplifiedXPath(xpath, thisDocument)
{
	// find all characters to end of line starting from '[' (open square bracket)
	var srch = new RegExp("\\[.*");
	//var srch = /\[.*/;

	var xarray = xpath.split("/");

	// Pop the leaf node element out.
	var leafNodeElement = xarray.pop();

	var flatxpath = '/';
	// xarray does not contain the leaf node now - has been popped out.
	for (i=0; i<xarray.length;i++)
	{
		if (isEmpty(xarray[i]))
		{
			continue;
		}
		// strip all characters starting from '['
		sub = xarray[i].replace(srch, "");

		flatxpath = flatxpath + sub + '/';
	}

	// Add back the leaf node element
	flatxpath = flatxpath + leafNodeElement;

	//myalert('flat path ' + flatxpath);

	var node = getNodeForFullXPath(flatxpath, thisDocument);

	return node;
}

//	If id exists as attribute, do getElementById()
//	Else, if name exists as attribute, do getElementsByName() and check for single hit.
function getNodeByLeafNodeAttribs(attType, attValue, thisDocument)
{
	var node;

	//myalert('getNodeByLeafNodeAttribs: ' + attValue + ' title: ' + thisDocument.title);

	if (isEmpty(attValue))
	{
		return node;
	}

	if (!thisDocument)
	{
		myalert('doc obj is null');
		return node;
	}

	try {

		if (attType == "id")
		{
			myalert('Search by Id - 1: ' + attValue);

			/*
			if (!thisDocument)
				myalert('thisDoc is null');
			else
				myalert('thisDoc is not null');
			*/

			try
			{
				node = thisDocument.getElementById(attValue);

				if (!node)
				{
				    myalert('Search by Id Failed: ' + attValue);

					// Some sites use random number prefixed to element names or ids, and this random number is in a hidden
					// element. QuickFix: We prefix these elements' relevant attributes with keyword 'cgps'
					var srcPattern = /cgps/;
					if (srcPattern.test(attValue))
					{
						var wildCardId = attValue.replace(srcPattern, "");

						// syntax
						// document.querySelectorAll('input[name*="' + "Password" + '"]');
						var idElems = thisDocument.querySelectorAll('input[id*="' +  wildCardId + '"]');

						// If multiple elements with same name, fail this level since we cannot determine anything.
						// If single, use it.
						if ((idElems) && (1 === idElems.length)) {
							node = idElems[0];
						}
					}
				}
				if (node)
				    myalert('Found node using Id : ' + attValue);
			}
			catch (err)
			{
				myalert('getElementById returned exception: ' + err.message);
			}
		}

		// Check by name.
		if ((!node) && (attType == "name"))
		{
			try {
				myalert('getElementsByName trying by name:');

				var nameElems = thisDocument.getElementsByName(attValue);
				// If multiple elements with same name, fail this level since we cannot determine anything.
				// If single, use it.
				if ((nameElems) && (1 === nameElems.length)) {
					node = nameElems[0];
				}

				if (!node)
				{
					 myalert('Search by name Failed: ' + attValue);

					// Some sites use random number prefixed to element names or ids, and this random number is in a hidden
					// element. QuickFix: We prefix these elements' relevant attributes with keyword 'cgps'
					var srcPattern = /cgps/;
					if (srcPattern.test(attValue))
					{
						var wildCardName = attValue.replace(srcPattern, "");

						// syntax
						// document.querySelectorAll('input[name*="' + "Password" + '"]');
						nameElems = thisDocument.querySelectorAll('input[name*="' +  wildCardName + '"]');

						// If multiple elements with same name, fail this level since we cannot determine anything.
						// If single, use it.
						if ((nameElems) && (1 === nameElems.length)) {
							node = nameElems[0];
						}
					}
				}
				if (node)
    			    myalert('Found node using name : ' + attValue);
			}
			catch(err)
			{
				myalert('getElementsByName returned exception: ' + err.message);
			}
		}
	}
	catch(err) { }

	//myalert('getNodeByLeafNodeAttribs returning');

	// Return whatever we have now.
	return node;
}

function simulateClick(target, options)
{
	myalert ('in simulateClick');

	var event = target.ownerDocument.createEvent('MouseEvents'),
	options = options || {};

	//Set your default options to the right of ||
	var opts = {
	type: options.click                     || 'click',
	canBubble:options.canBubble             || true,
	cancelable:options.cancelable           || true,
	view:options.view                       || target.ownerDocument.defaultView,
	detail:options.detail                   || 1,
	screenX:options.screenX                 || 0, //The coordinates within the entire page
	screenY:options.screenY                 || 0,
	clientX:options.clientX                 || 0, //The coordinates within the viewport
	clientY:options.clientY                 || 0,
	ctrlKey:options.ctrlKey                 || false,
	altKey:options.altKey                   || false,
	shiftKey:options.shiftKey               || false,
	metaKey:options.metaKey                 || false, //I *think* 'meta' is 'Cmd/Apple' on Mac, and 'Windows key' on Win. Not sure, though!
	button:options.button                   || 0, //0 = left, 1 = middle, 2 = right
	relatedTarget:options.relatedTarget     || null
	};

	//Pass in the options
	event.initMouseEvent(
						 opts.type,
						 opts.canBubble,
						 opts.cancelable,
						 opts.view,
						 opts.detail,
						 opts.screenX,
						 opts.screenY,
						 opts.clientX,
						 opts.clientY,
						 opts.ctrlKey,
						 opts.altKey,
						 opts.shiftKey,
						 opts.metaKey,
						 opts.button,
						 opts.relatedTarget);

	myalert ('dispatchingevent simulateClick');

	//Fire the event
	target.dispatchEvent(event);
}

/////////////////
// Basic method to submit a value. If inputType == submit, then behavior is a bit different
function submitCredential(xPath, value, inputType)
{
	//alert('xPath: ' + xPath);
	//alert('inputType: ' + inputType);

	var result = "fail";
	//
	try {
		//
		var nodeList = document.evaluate(xPath, document, null, XPathResult.ANY_TYPE , null);

		if (nodeList)
		{
			var node = nodeList.iterateNext();

			if (node)
			{
				if (inputType.toLowerCase() == "submit")
				{
					// Ignore the 'value' argument. Set focus, and invoke a click.
					//node.focus();
					try {
						node.click();
					}
					catch(err)
					{
						// If click failed, try onclick...
						try {
							node.onclick();
						}
						catch(err)
						{
							// If that failed too, dispatch a click event
							try {
								if(document.dispatchEvent)
								{ // W3C
									var oEvent = document.createEvent( "MouseEvents" );
									oEvent.initMouseEvent("click", true, true,window, 1, 1, 1, 1, 1, false, false, false, false, 0, node);
									node.dispatchEvent( oEvent );
								}
								else if(document.fireEvent) { // IE
									node.fireEvent("onclick");
								}
							}
							catch(err)
							{
								result = "submitCredential: Failed to submit: " + xPath;
							}
						}
					}
					result = "success";
				}
				else
				{
					// Set focus, set value (needs to be keystrokes, maybe), and then lose focus to trigger any
					// onblur event that this element may have.
					//alert('setting value: ');
					try
					{
						node.focus();
						node.value = value;
						node.blur();
						result = "success";
					}
					catch(err)
					{
						result = "submitCredential: Failed to set value for: " + xPath;
					}
				}
			}
			else
			{
				result = "submitCredential: evaluate returned empty nodeList for: " + xPath;
			}
		}
		else
		{
			result = "submitCredential: evaluate returned nodeList = nil for: " + xPath;
		}
	}
	catch(err)
	{
		//
		result = "submitCredential: evaluate failed: " + xPath;
	}

	return result;
}

// TO DO - correct Implementation
function getCredentialsJSON(jsonString)
{
	var myObject;

	myalert(jsonString);

	try
	{
		// Convert the jsonString to an object so attributes can be accessed.
		myObject = eval('(' + jsonString + ')');

		// Test..
		var ss = myObject.LoginElements[0].XPath;

		// XPath and XPathValue comes in with a ? instead of a ' (single quote) for values in its predicates
		// Caller replaced it 'cos eval does not work correctly if single quote exists in input jsonstring

		// Here replace all occurrences of ? with a '. Note: ? is a special character in regex, so need to escape it.
		var newstring = ss.replace(/\?_\?/g, "'");
		myalert(newstring);

		// Now, got the optional, xpath and xpathvalue in proper format.
		// Loop through the fetch values...

	}
	catch(err)
	{
		//alert('failed');
	}
}

function submitCredentialsJSON(jsonString)
{
}

// Check if a given element exists. Obsolete...remove
function doesElementExist(obj)
{
	if (document.getElementById(obj))
	{
		return "1";
	}
	else
	{
		return "0";
	}
}

//
function sendEnterKey()
{
	// Create new event
	var e = document.createEvent('KeyboardEvent');

	// Init key event
	e.initKeyEvent('keydown', true, true, window, false, false, false, false, 13, 0);

	// Dispatch event into document
	document.body.dispatchEvent(e);
}

